'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var Resizable = function Resizable(el, header, onResizing, onStartResizing, onStopResizing) {
  onResizing = onResizing ? onResizing : function () {
    return;
  };
  onStartResizing = onStartResizing ? onStartResizing : function () {
    return;
  };
  onStopResizing = onStopResizing ? onStopResizing : function () {
    return;
  };

  var opts = header.props.resizeOptions;
  if (el.className.indexOf('resizable') === -1) {
    return;
  }
  var resizable = el;
  var resizer = resizable.querySelector('.resizer');

  var startX = void 0;
  var stopX = void 0;
  var startWidth = void 0;
  var stopWidth = void 0;

  var doDrag = function doDrag(e) {
    var newWidth = startWidth + e.clientX - startX;
    if (opts.minWidth && newWidth < opts.minWidth || opts.maxWidth && newWidth > opts.maxWidth) {
      return;
    }
    resizable.style.width = newWidth + 'px';
    onResizing(e, newWidth);
  };

  var stopDrag = function stopDrag(e) {
    stopX = e.clientX;
    stopWidth = parseInt(document.defaultView.getComputedStyle(resizable).width, 10);
    document.documentElement.removeEventListener('mousemove', doDrag, false);
    document.documentElement.removeEventListener('mouseup', stopDrag, false);
    onStopResizing(e, stopX, stopWidth);
  };

  var initDrag = function initDrag(e) {
    startX = e.clientX;
    startWidth = parseInt(document.defaultView.getComputedStyle(resizable).width, 10);
    document.documentElement.addEventListener('mousemove', doDrag, false);
    document.documentElement.addEventListener('mouseup', stopDrag, false);
    onStartResizing(e, startX, startWidth);
  };

  resizer.addEventListener('mousedown', initDrag, false);
};

var _default = Resizable;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Resizable, 'Resizable', '/Users/sameer/www/test/react/react-bootstrap-table/src/resizable.js');

  __REACT_HOT_LOADER__.register(_default, 'default', '/Users/sameer/www/test/react/react-bootstrap-table/src/resizable.js');
}();

;